(function () {
    "use strict";

    angular.module("amp-async-function", []);
})();
(function () {
    "use strict";

    angular
        .module("amp-async-function")
        .factory("asyncFunction", asyncFunction);

    asyncFunction.$inject = ["$q", "$timeout"];
    function asyncFunction($q, $timeout) {
        var asyncFunction = {
            execute: execute
        };

        return asyncFunction;

        function execute(func, params, delay) {
            delay = delay || 0;
            params = params || [];
            
            var deferred = $q.defer();

            $timeout(executeFunction, delay);

            function executeFunction() {
                var result = func.apply(null, params);
                deferred.resolve(result);
            }

            return deferred.promise;
        }
    }
})();